diff -uNr openmp-3.5.0.src/runtime/src/kmp_runtime.c openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c
--- openmp-3.5.0.src/runtime/src/kmp_runtime.c	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c	2014-10-24 19:58:41.000000000 -0400
@@ -6532,7 +5029,7 @@
     KA_TRACE( 10, ("__kmp_launch_thread: T#%d start\n", gtid ) );
 
     if( __kmp_env_consistency_check ) {
-        this_thr -> th.th_cons = __kmp_allocate_cons_stack( gtid );  // ATT: Memory leak?
+        this_thr->th.th_cons = __kmp_allocate_cons_stack( gtid );  // ATT: Memory leak?
     }
 
     /* This is the place where threads wait for work */
@@ -6553,37 +5050,32 @@
             /* we were just woken up, so run our new task */
             if ( TCR_SYNC_PTR((*pteam)->t.t_pkfn) != NULL ) {
                 int rc;
-                KA_TRACE( 20, ("__kmp_launch_thread: T#%d(%d:%d) invoke microtask = %p\n",
-                    gtid, (*pteam)->t.t_id, __kmp_tid_from_gtid(gtid), (*pteam)->t.t_pkfn ));
+                KA_TRACE(20, ("__kmp_launch_thread: T#%d(%d:%d) invoke microtask = %p\n",
+                              gtid, (*pteam)->t.t_id, __kmp_tid_from_gtid(gtid), (*pteam)->t.t_pkfn));
 
-#if KMP_ARCH_X86 || KMP_ARCH_X86_64
-                if ( __kmp_inherit_fp_control && (*pteam)->t.t_fp_control_saved ) {
-                    __kmp_clear_x87_fpu_status_word();
-                    __kmp_load_x87_fpu_control_word( &(*pteam)->t.t_x87_fpu_control_word );
-                    __kmp_load_mxcsr( &(*pteam)->t.t_mxcsr );
-                }
-#endif /* KMP_ARCH_X86 || KMP_ARCH_X86_64 */
+                updateHWFPControl (*pteam);
 
-                rc = (*pteam) -> t.t_invoke( gtid );
+                KMP_STOP_EXPLICIT_TIMER(USER_launch_thread_loop);
+                {
+                    KMP_TIME_BLOCK(USER_worker_invoke);
+                    rc = (*pteam)->t.t_invoke( gtid );
+                }
+                KMP_START_EXPLICIT_TIMER(USER_launch_thread_loop);
                 KMP_ASSERT( rc );
 
                 KMP_MB();
-                KA_TRACE( 20, ("__kmp_launch_thread: T#%d(%d:%d) done microtask = %p\n",
-                        gtid, (*pteam)->t.t_id, __kmp_tid_from_gtid(gtid), (*pteam)->t.t_pkfn ));
+                KA_TRACE(20, ("__kmp_launch_thread: T#%d(%d:%d) done microtask = %p\n",
+                              gtid, (*pteam)->t.t_id, __kmp_tid_from_gtid(gtid), (*pteam)->t.t_pkfn));
             }
-
             /* join barrier after parallel region */
             __kmp_join_barrier( gtid );
         }
     }
-    TCR_SYNC_PTR(__kmp_global.g.g_done);
+    TCR_SYNC_PTR((intptr_t)__kmp_global.g.g_done);
 
-#if OMP_30_ENABLED
     if ( TCR_PTR( this_thr->th.th_task_team ) != NULL ) {
         __kmp_unref_task_team( this_thr->th.th_task_team, this_thr );
     }
-#endif /* OMP_30_ENABLED */
-
     /* run the destructors for the threadprivate data for this thread */
     __kmp_common_destroy_gtid( gtid );
 
@@ -6595,8 +5087,6 @@
 /* ------------------------------------------------------------------------ */
 /* ------------------------------------------------------------------------ */
 
-
-
 void
 __kmp_internal_end_dest( void *specific_gtid )
 {
@@ -6705,11 +5195,8 @@
             /* Assume the threads are at the fork barrier here */
             KA_TRACE( 20, ("__kmp_reap_thread: releasing T#%d from fork barrier for reap\n", gtid ) );
             /* Need release fence here to prevent seg faults for tree forkjoin barrier (GEH) */
-            __kmp_release(
-                thread,
-                &thread->th.th_bar[ bs_forkjoin_barrier ].bb.b_go,
-                kmp_release_fence
-            );
+            kmp_flag_64 flag(&thread->th.th_bar[ bs_forkjoin_barrier ].bb.b_go, thread);
+            __kmp_release_64(&flag);
         }; // if
 
 
@@ -6818,7 +5305,7 @@
 
     for( i=0 ; i<__kmp_threads_capacity ; i++ )
         if( __kmp_root[i] )
-            if( __kmp_root[i] -> r.r_active )
+            if( __kmp_root[i]->r.r_active )
                 break;
     KMP_MB();       /* Flush all pending memory write invalidates.  */
     TCW_SYNC_4(__kmp_global.g.g_done, TRUE);
@@ -6854,8 +5341,8 @@
             /* make sure that everything has properly ended */
             for ( i = 0; i < __kmp_threads_capacity; i++ ) {
                 if( __kmp_root[i] ) {
-                    KMP_ASSERT( ! KMP_UBER_GTID( i ) );
-                    KMP_ASSERT( ! __kmp_root[i] -> r.r_active );
+//                    KMP_ASSERT( ! KMP_UBER_GTID( i ) );         // AC: there can be uber threads alive here
+                    KMP_ASSERT( ! __kmp_root[i]->r.r_active );  // TODO: can they be active?
                 }
             }
         #endif
@@ -6885,9 +5372,7 @@
             __kmp_reap_team( team );
         }; // while
 
-        #if OMP_30_ENABLED
-            __kmp_reap_task_teams( );
-        #endif /* OMP_30_ENABLED */
+        __kmp_reap_task_teams( );
 
         for ( i = 0; i < __kmp_threads_capacity; ++ i ) {
             // TBD: Add some checking...
@@ -6962,7 +5447,7 @@
             /* we don't know who we are, but we may still shutdown the library */
         } else if( KMP_UBER_GTID( gtid )) {
             /* unregister ourselves as an uber thread.  gtid is no longer valid */
-            if( __kmp_root[gtid] -> r.r_active ) {
+            if( __kmp_root[gtid]->r.r_active ) {
                 __kmp_global.g.g_abort = -1;
                 TCW_SYNC_4(__kmp_global.g.g_done, TRUE);
                 KA_TRACE( 10, ("__kmp_internal_end_library: root still active, abort T#%d\n", gtid ));
@@ -7066,7 +5551,7 @@
             /* we don't know who we are */
         } else if( KMP_UBER_GTID( gtid )) {
         /* unregister ourselves as an uber thread.  gtid is no longer valid */
-            if( __kmp_root[gtid] -> r.r_active ) {
+            if( __kmp_root[gtid]->r.r_active ) {
                 __kmp_global.g.g_abort = -1;
                 TCW_SYNC_4(__kmp_global.g.g_done, TRUE);
                 KA_TRACE( 10, ("__kmp_internal_end_thread: root still active, abort T#%d\n", gtid ));
@@ -7079,14 +5564,12 @@
             /* just a worker thread, let's leave */
             KA_TRACE( 10, ("__kmp_internal_end_thread: worker thread T#%d\n", gtid ));
 
-            #if OMP_30_ENABLED
-                if ( gtid >= 0 ) {
-                    kmp_info_t *this_thr = __kmp_threads[ gtid ];
-                    if (TCR_PTR(this_thr->th.th_task_team) != NULL) {
-                        __kmp_unref_task_team(this_thr->th.th_task_team, this_thr);
-                    }
+            if ( gtid >= 0 ) {
+                kmp_info_t *this_thr = __kmp_threads[ gtid ];
+                if (TCR_PTR(this_thr->th.th_task_team) != NULL) {
+                    __kmp_unref_task_team(this_thr->th.th_task_team, this_thr);
                 }
-            #endif /* OMP_30_ENABLED */
+            }
 
             KA_TRACE( 10, ("__kmp_internal_end_thread: worker thread done, exiting T#%d\n", gtid ));
             return;
@@ -7100,7 +5583,7 @@
     //     keeping worker threads alive until the program shutdown.
     // OM: Removed Linux* OS restriction to fix the crash on OS X* (DPD200239966) and
     //     Windows(DPD200287443) that occurs when using critical sections from foreign threads.
-        KA_TRACE( 10, ("__kmp_internal_end_thread: exiting\n") );
+        KA_TRACE( 10, ("__kmp_internal_end_thread: exiting T#%d\n", gtid_req) );
         return;
     #endif
     /* synchronize the termination process */
@@ -7144,7 +5627,7 @@
     __kmp_release_bootstrap_lock( &__kmp_forkjoin_lock );
     __kmp_release_bootstrap_lock( &__kmp_initz_lock );
 
-    KA_TRACE( 10, ("__kmp_internal_end_thread: exit\n" ) );
+    KA_TRACE( 10, ("__kmp_internal_end_thread: exit T#%d\n", gtid_req ) );
 
     #ifdef DUMP_DEBUG_ON_EXIT
         if ( __kmp_debug_buf )
@@ -7313,7 +5796,7 @@
     int i, gtid;
     int size;
 
-    KA_TRACE( 10, ("__kmp_serial_initialize: enter\n" ) );
+    KA_TRACE( 10, ("__kmp_do_serial_initialize: enter\n" ) );
 
     KMP_DEBUG_ASSERT( sizeof( kmp_int32 ) == 4 );
     KMP_DEBUG_ASSERT( sizeof( kmp_uint32 ) == 4 );
@@ -7398,9 +5881,7 @@
     __kmp_static = kmp_sch_static_balanced;
     // AC: do not use analytical here, because it is non-monotonous
     //__kmp_guided = kmp_sch_guided_iterative_chunked;
-    #if OMP_30_ENABLED
     //__kmp_auto = kmp_sch_guided_analytical_chunked; // AC: it is the default, no need to repeate assignment
-    #endif // OMP_30_ENABLED
     // Barrier initialization. Moved here from __kmp_env_initialize() Barrier branch bit control and barrier method
     // control parts
     #if KMP_FAST_REDUCTION_BARRIER
@@ -7430,9 +5911,15 @@
         #undef kmp_reduction_barrier_gather_bb
     #endif // KMP_FAST_REDUCTION_BARRIER
     #if KMP_MIC
-        // AC: plane=3,2, forkjoin=2,1 are optimal for 240 threads on KNC
-        __kmp_barrier_gather_branch_bits [ 0 ] = 3;  // plane gather
-        __kmp_barrier_release_branch_bits[ 1 ] = 1;  // forkjoin release
+    // AC: plane=3,2, forkjoin=2,1 are optimal for 240 threads on KNC
+    __kmp_barrier_gather_branch_bits [ bs_plain_barrier ] = 3;  // plane gather
+    __kmp_barrier_release_branch_bits[ bs_forkjoin_barrier ] = 1;  // forkjoin release
+    __kmp_barrier_gather_pattern [ bs_forkjoin_barrier ] = bp_hierarchical_bar;
+    __kmp_barrier_release_pattern[ bs_forkjoin_barrier ] = bp_hierarchical_bar;
+#if KMP_FAST_REDUCTION_BARRIER
+    __kmp_barrier_gather_pattern [ bs_reduction_barrier ] = bp_hierarchical_bar;
+    __kmp_barrier_release_pattern[ bs_reduction_barrier ] = bp_hierarchical_bar;
+#endif
     #endif
 
     // From KMP_CHECKS initialization
@@ -7449,6 +5936,7 @@
     __kmp_global.g.g_dynamic_mode = dynamic_default;
 
     __kmp_env_initialize( NULL );
+
     // Print all messages in message catalog for testing purposes.
     #ifdef KMP_DEBUG
         char const * val = __kmp_env_get( "KMP_DUMP_CATALOG" );
@@ -7654,13 +6142,9 @@
         for ( i = 0; i < __kmp_threads_capacity; i++ ) {
             kmp_info_t *thread = __kmp_threads[ i ];
             if ( thread == NULL ) continue;
-#if OMP_30_ENABLED
             if ( thread->th.th_current_task->td_icvs.nproc != 0 ) continue;
-#else
-            if ( thread->th.th_team->t.t_set_nproc[ thread->th.th_info.ds.ds_tid ]  != 0 ) continue;
-#endif /* OMP_30_ENABLED */
 
-            set__nproc_p( __kmp_threads[ i ], __kmp_dflt_team_nth );
+            set__nproc( __kmp_threads[ i ], __kmp_dflt_team_nth );
         }
     }
     KA_TRACE( 20, ("__kmp_middle_initialize: final value for __kmp_dflt_team_nth = %d\n",
@@ -7780,16 +6264,15 @@
 
     /* none of the threads have encountered any constructs, yet. */
     this_thr->th.th_local.this_construct = 0;
-    this_thr->th.th_local.last_construct = 0;
 #if KMP_CACHE_MANAGE
-    KMP_CACHE_PREFETCH( &this_thr -> th.th_bar[ bs_forkjoin_barrier ].bb.b_arrived );
+    KMP_CACHE_PREFETCH( &this_thr->th.th_bar[ bs_forkjoin_barrier ].bb.b_arrived );
 #endif /* KMP_CACHE_MANAGE */
     dispatch = (kmp_disp_t *)TCR_PTR(this_thr->th.th_dispatch);
     KMP_DEBUG_ASSERT( dispatch );
-    KMP_DEBUG_ASSERT( team -> t.t_dispatch );
-    //KMP_DEBUG_ASSERT( this_thr -> th.th_dispatch == &team -> t.t_dispatch[ this_thr->th.th_info.ds.ds_tid ] );
+    KMP_DEBUG_ASSERT( team->t.t_dispatch );
+    //KMP_DEBUG_ASSERT( this_thr->th.th_dispatch == &team->t.t_dispatch[ this_thr->th.th_info.ds.ds_tid ] );
 
-    dispatch -> th_disp_index = 0;    /* reset the dispatch buffer counter */
+    dispatch->th_disp_index = 0;    /* reset the dispatch buffer counter */
 
     if( __kmp_env_consistency_check )
         __kmp_push_parallel( gtid, team->t.t_ident );
@@ -7811,7 +6294,7 @@
     int          rc;
     int          tid      = __kmp_tid_from_gtid( gtid );
     kmp_info_t  *this_thr = __kmp_threads[ gtid ];
-    kmp_team_t  *team     = this_thr -> th.th_team;
+    kmp_team_t  *team     = this_thr->th.th_team;
 
     __kmp_run_before_invoked_task( gtid, tid, this_thr, team );
 #if USE_ITT_BUILD
@@ -7819,6 +6302,9 @@
         __kmp_itt_stack_callee_enter( (__itt_caller)team->t.t_stack_id ); // inform ittnotify about entering user's code
     }
 #endif /* USE_ITT_BUILD */
+#if INCLUDE_SSC_MARKS
+    SSC_MARK_INVOKING();
+#endif
     rc = __kmp_invoke_microtask( (microtask_t) TCR_SYNC_PTR(team->t.t_pkfn),
       gtid, tid, (int) team->t.t_argc, (void **) team->t.t_argv );
 
@@ -7834,27 +6320,30 @@
 
 #if OMP_40_ENABLED
 void
-__kmp_teams_master( microtask_t microtask, int gtid )
+__kmp_teams_master( int gtid )
 {
     // This routine is called by all master threads in teams construct
-    kmp_info_t  *this_thr = __kmp_threads[ gtid ];
-    kmp_team_t  *team = this_thr -> th.th_team;
+    kmp_info_t *thr = __kmp_threads[ gtid ];
+    kmp_team_t *team = thr->th.th_team;
     ident_t     *loc =  team->t.t_ident;
-
-#if KMP_DEBUG
-    int          tid = __kmp_tid_from_gtid( gtid );
+    thr->th.th_set_nproc = thr->th.th_teams_size.nth;
+    KMP_DEBUG_ASSERT( thr->th.th_teams_microtask );
+    KMP_DEBUG_ASSERT( thr->th.th_set_nproc );
     KA_TRACE( 20, ("__kmp_teams_master: T#%d, Tid %d, microtask %p\n",
-                   gtid, tid, microtask) );
-#endif
-
+                   gtid, __kmp_tid_from_gtid( gtid ), thr->th.th_teams_microtask ) );
     // Launch league of teams now, but not let workers execute
     // (they hang on fork barrier until next parallel)
-    this_thr->th.th_set_nproc = this_thr->th.th_set_nth_teams;
-    __kmp_fork_call( loc, gtid, TRUE,
+#if INCLUDE_SSC_MARKS
+    SSC_MARK_FORKING();
+#endif
+    __kmp_fork_call( loc, gtid, fork_context_intel,
             team->t.t_argc,
-            microtask,
+            (microtask_t)thr->th.th_teams_microtask,
             VOLATILE_CAST(launch_t) __kmp_invoke_task_func,
             NULL );
+#if INCLUDE_SSC_MARKS
+    SSC_MARK_JOINING();
+#endif
     __kmp_join_call( loc, gtid, 1 ); // AC: last parameter "1" eliminates join barrier which won't work because
                                      // worker threads are in a fork barrier waiting for more parallel regions
 }
@@ -7862,13 +6351,15 @@
 int
 __kmp_invoke_teams_master( int gtid )
 {
+    kmp_info_t  *this_thr = __kmp_threads[ gtid ];
+    kmp_team_t  *team     = this_thr->th.th_team;
     #if KMP_DEBUG
     if ( !__kmp_threads[gtid]-> th.th_team->t.t_serialized )
         KMP_DEBUG_ASSERT( (void*)__kmp_threads[gtid]-> th.th_team->t.t_pkfn == (void*)__kmp_teams_master );
     #endif
-
-    __kmp_teams_master( (microtask_t)__kmp_threads[gtid]->th.th_team_microtask, gtid );
-
+    __kmp_run_before_invoked_task( gtid, 0, this_thr, team );
+    __kmp_teams_master( gtid );
+    __kmp_run_after_invoked_task( gtid, 0, this_thr, team );
     return 1;
 }
 #endif /* OMP_40_ENABLED */
@@ -7884,7 +6375,7 @@
     kmp_info_t *thr = __kmp_threads[gtid];
 
     if( num_threads > 0 )
-        thr -> th.th_set_nproc = num_threads;
+        thr->th.th_set_nproc = num_threads;
 }
 
 #if OMP_40_ENABLED
@@ -7895,20 +6386,21 @@
 __kmp_push_num_teams( ident_t *id, int gtid, int num_teams, int num_threads )
 {
     kmp_info_t *thr = __kmp_threads[gtid];
-    // The number of teams is the number of threads in the outer "parallel"
-    if( num_teams > 0 ) {
-        thr -> th.th_set_nproc = num_teams;
-    } else {
-        thr -> th.th_set_nproc = 1;  // AC: default number of teams is 1;
-                                     // TODO: should it be __kmp_ncores ?
+    KMP_DEBUG_ASSERT(num_teams >= 0);
+    KMP_DEBUG_ASSERT(num_threads >= 0);
+    if( num_teams == 0 ) {
+        num_teams = 1;    // default number of teams is 1.
     }
-    // The number of threads is for inner parallel regions
+    // Set number of teams (number of threads in the outer "parallel" of the teams)
+    thr->th.th_set_nproc = thr->th.th_teams_size.nteams = num_teams;
+
+    // Remember the number of threads for inner parallel regions
     if( num_threads > 0 ) {
-        thr -> th.th_set_nth_teams = num_threads;
+        thr->th.th_teams_size.nth = num_threads;
     } else {
         if( !TCR_4(__kmp_init_middle) )
-            __kmp_middle_initialize();
-        thr -> th.th_set_nth_teams = __kmp_avail_proc / thr -> th.th_set_nproc;
+            __kmp_middle_initialize();  // get __kmp_avail_proc calculated
+        thr->th.th_teams_size.nth = __kmp_avail_proc / num_teams;
     }
 }
 
@@ -7920,7 +6412,7 @@
 __kmp_push_proc_bind( ident_t *id, int gtid, kmp_proc_bind_t proc_bind )
 {
     kmp_info_t *thr = __kmp_threads[gtid];
-    thr -> th.th_set_proc_bind = proc_bind;
+    thr->th.th_set_proc_bind = proc_bind;
 }
 
 #endif /* OMP_40_ENABLED */
@@ -7937,25 +6429,25 @@
 #endif /* KMP_DEBUG */
 
     KMP_DEBUG_ASSERT( team );
-    KMP_DEBUG_ASSERT( this_thr -> th.th_team  ==  team );
+    KMP_DEBUG_ASSERT( this_thr->th.th_team  ==  team );
     KMP_ASSERT(       KMP_MASTER_GTID(gtid) );
     KMP_MB();       /* Flush all pending memory write invalidates.  */
 
-    team -> t.t_construct = 0;          /* no single directives seen yet */
-    team -> t.t_ordered.dt.t_value = 0; /* thread 0 enters the ordered section first */
+    team->t.t_construct = 0;          /* no single directives seen yet */
+    team->t.t_ordered.dt.t_value = 0; /* thread 0 enters the ordered section first */
 
     /* Reset the identifiers on the dispatch buffer */
-    KMP_DEBUG_ASSERT( team -> t.t_disp_buffer );
+    KMP_DEBUG_ASSERT( team->t.t_disp_buffer );
     if ( team->t.t_max_nproc > 1 ) {
         int i;
         for (i = 0; i <  KMP_MAX_DISP_BUF; ++i)
-            team -> t.t_disp_buffer[ i ].buffer_index = i;
+            team->t.t_disp_buffer[ i ].buffer_index = i;
     } else {
-        team -> t.t_disp_buffer[ 0 ].buffer_index = 0;
+        team->t.t_disp_buffer[ 0 ].buffer_index = 0;
     }
 
     KMP_MB();       /* Flush all pending memory write invalidates.  */
-    KMP_ASSERT( this_thr -> th.th_team  ==  team );
+    KMP_ASSERT( this_thr->th.th_team  ==  team );
 
 #ifdef KMP_DEBUG
     for( f=0 ; f<team->t.t_nproc ; f++ ) {
@@ -7975,7 +6467,7 @@
     kmp_info_t *this_thr = __kmp_threads[gtid];
 
     KMP_DEBUG_ASSERT( team );
-    KMP_DEBUG_ASSERT( this_thr -> th.th_team  ==  team );
+    KMP_DEBUG_ASSERT( this_thr->th.th_team  ==  team );
     KMP_ASSERT(       KMP_MASTER_GTID(gtid) );
     KMP_MB();       /* Flush all pending memory write invalidates.  */
 
@@ -7995,7 +6487,7 @@
     __kmp_join_barrier( gtid );  /* wait for everyone */
 
     KMP_MB();       /* Flush all pending memory write invalidates.  */
-    KMP_ASSERT( this_thr -> th.th_team  ==  team );
+    KMP_ASSERT( this_thr->th.th_team  ==  team );
 }
 
 
@@ -8051,11 +6543,7 @@
     KB_TRACE( 20, ("__kmp_load_balance_nproc: called root:%p set_nproc:%d\n",
                 root, set_nproc ) );
     KMP_DEBUG_ASSERT( root );
-    #if OMP_30_ENABLED
     KMP_DEBUG_ASSERT( root->r.r_root_team->t.t_threads[0]->th.th_current_task->td_icvs.dynamic == TRUE );
-    #else
-    KMP_DEBUG_ASSERT( root->r.r_root_team->t.t_set_dynamic[0] == TRUE );
-    #endif
     KMP_DEBUG_ASSERT( set_nproc > 1 );
 
     if ( set_nproc == 1) {
@@ -8197,6 +6685,11 @@
 
     __kmp_i18n_catclose();
 
+#if KMP_STATS_ENABLED
+    __kmp_accumulate_stats_at_exit();
+    __kmp_stats_list.deallocate();
+#endif
+
     KA_TRACE( 10, ("__kmp_cleanup: exit\n" ) );
 }
 
@@ -8238,7 +6731,7 @@
     /* this is a very important step as it will register new sibling threads
      * and assign these new uber threads a new gtid */
     gtid = __kmp_entry_gtid();
-    root = __kmp_threads[ gtid ] -> th.th_root;
+    root = __kmp_threads[ gtid ]->th.th_root;
     KMP_ASSERT( KMP_UBER_GTID( gtid ));
 
     if( root->r.r_begin ) return;
@@ -8248,7 +6741,7 @@
         return;
     }
 
-    root -> r.r_begin = TRUE;
+    root->r.r_begin = TRUE;
 
     __kmp_release_lock( & root->r.r_begin_lock, gtid );
 }
@@ -8269,7 +6762,7 @@
     gtid = __kmp_entry_gtid();
     thread = __kmp_threads[ gtid ];
 
-    root = thread -> th.th_root;
+    root = thread->th.th_root;
 
     KA_TRACE( 20, ("__kmp_user_set_library: enter T#%d, arg: %d, %d\n", gtid, arg, library_serial ));
     if (root->r.r_in_parallel) { /* Must be called in serial section of top-level thread */
@@ -8279,16 +6772,16 @@
 
     switch ( arg ) {
     case library_serial :
-        thread -> th.th_set_nproc = 0;
-        set__nproc_p( thread, 1 );
+        thread->th.th_set_nproc = 0;
+        set__nproc( thread, 1 );
         break;
     case library_turnaround :
-        thread -> th.th_set_nproc = 0;
-        set__nproc_p( thread, __kmp_dflt_team_nth ? __kmp_dflt_team_nth : __kmp_dflt_team_nth_ub );
+        thread->th.th_set_nproc = 0;
+        set__nproc( thread, __kmp_dflt_team_nth ? __kmp_dflt_team_nth : __kmp_dflt_team_nth_ub );
         break;
     case library_throughput :
-        thread -> th.th_set_nproc = 0;
-        set__nproc_p( thread, __kmp_dflt_team_nth ? __kmp_dflt_team_nth : __kmp_dflt_team_nth_ub );
+        thread->th.th_set_nproc = 0;
+        set__nproc( thread, __kmp_dflt_team_nth ? __kmp_dflt_team_nth : __kmp_dflt_team_nth_ub );
         break;
     default:
         KMP_FATAL( UnknownLibraryType, arg );
@@ -8372,20 +6865,20 @@
     else if (blocktime > KMP_MAX_BLOCKTIME)
         blocktime = KMP_MAX_BLOCKTIME;
 
-    set__blocktime_team( thread -> th.th_team, tid, blocktime );
-    set__blocktime_team( thread -> th.th_serial_team, 0, blocktime );
+    set__blocktime_team( thread->th.th_team, tid, blocktime );
+    set__blocktime_team( thread->th.th_serial_team, 0, blocktime );
 
     /* Calculate and set blocktime intervals for the teams */
     bt_intervals = KMP_INTERVALS_FROM_BLOCKTIME(blocktime, __kmp_monitor_wakeups);
 
-    set__bt_intervals_team( thread -> th.th_team, tid, bt_intervals );
-    set__bt_intervals_team( thread -> th.th_serial_team, 0, bt_intervals );
+    set__bt_intervals_team( thread->th.th_team, tid, bt_intervals );
+    set__bt_intervals_team( thread->th.th_serial_team, 0, bt_intervals );
 
     /* Set whether blocktime has been set to "TRUE" */
     bt_set = TRUE;
 
-    set__bt_set_team( thread -> th.th_team, tid, bt_set );
-    set__bt_set_team( thread -> th.th_serial_team, 0, bt_set );
+    set__bt_set_team( thread->th.th_team, tid, bt_set );
+    set__bt_set_team( thread->th.th_serial_team, 0, bt_set );
     KF_TRACE(10, ( "kmp_set_blocktime: T#%d(%d:%d), blocktime=%d, bt_intervals=%d, monitor_updates=%d\n",
                   __kmp_gtid_from_tid(tid, thread->th.th_team),
                   thread->th.th_team->t.t_id, tid, blocktime, bt_intervals, __kmp_monitor_wakeups ) );
@@ -8475,7 +6968,7 @@
 
         #elif KMP_ARCH_X86 || KMP_ARCH_ARM
 
-            #if KMP_AFFINITY_SUPPORTED
+            #if KMP_OS_LINUX || KMP_OS_WINDOWS
 
                 // basic tuning
 
@@ -8553,7 +7046,7 @@
 // this function is for testing set/get/determine reduce method
 kmp_int32
 __kmp_get_reduce_method( void ) {
-    return ( ( __kmp_entry_thread() -> th.th_local.packed_reduction_method ) >> 8 );
+    return ( ( __kmp_entry_thread()->th.th_local.packed_reduction_method ) >> 8 );
 }
 
 /* ------------------------------------------------------------------------ */
